; conDeb.pb
; (constant debugger)
; searches clipboard text for constants
; and sets a PureBasic Debug code for these
; constants as new clipboard text.

; http://www.purebasic.fr/german/viewtopic.php?t=14517
; by '#null' (thanks to 'sibru')



text.s = GetClipboardText()

NewList const.s()
AddElement(const())

For i=1 To Len(text)
  char = Asc( Mid(text,i,1) )
  If char = 35;"#"
    switch = 1
    const()+"#"
  ElseIf switch And Not FindString("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_", Chr(char), 1)
    switch = 0
    AddElement(const())
  ElseIf switch
    const()+Chr(char)
  EndIf
Next

text=""
ForEach const()
  If const()
    text + ";" + const() + #CRLF$
  EndIf
Next
text + #CRLF$
ForEach const()
  If const()
    text + "Debug " + Chr(34) + const() + " = " + Chr(34) + " + Str(" + const() + ")" + #CRLF$
  EndIf
Next

SetClipboardText(text)







; [sample text for testing]
; 
; 
; 
; Description
; After a WindowEvent() <windowevent.html> Or WaitWindowEvent() <waitwindowevent.html> function, use this function To determine of which type the event is. The following values are possible, If an event of the type #PB_Event_Gadget (library Gadget <../gadget/index.html>) Or #PB_Event_SysTray (library Systray <../systray/index.html>) occurs: 
;   #PB_EventType_LeftClick       : Left mouse button click
;   #PB_EventType_RightClick      : right mouse button click
;   #PB_EventType_LeftDoubleClick : Left mouse button double click
;   #PB_EventType_RightDoubleClick: Right mouse button double click
;   #PB_EventType_Focus           : Get the focus.
;   #PB_EventType_LostFocus       : Lose the focus.
;   #PB_EventType_Change          : Content change.
;   #PB_EventType_DragStart       : The user tries To start a Drag & Drop <../dragdrop/index.html> operation.
; The following gadgets support EventType(): 
; 
; - ExplorerListGadget() <../gadget/explorerlistgadget.html> 
; - ExplorerTreeGadget() <../gadget/explorertreegadget.html> 
; 
; 'ParentWindowID' is an optional parameter which specify on which window the new window belongs To. 'ParentWindowID' value can be easily obtained With WindowID(). 
; 
; Possible flags are: 
;   #PB_Window_SystemMenu    : Enables the system menu on the window title bar.
;   #PB_Window_MinimizeGadget: Adds the minimize gadget To the window title bar. #PB_Window_SystemMenu is automatically added.
;   #PB_Window_MaximizeGadget: Adds the maximize gadget To the window title bar. #PB_Window_SystemMenu is automatically added.
;   #PB_Window_SizeGadget    : Adds the sizeable feature To a window.
;   #PB_Window_Invisible     : Creates the window but don't display. Not supported on AmigaOS.
;   #PB_Window_TitleBar      : Creates a window With a titlebar.
;   #PB_Window_BorderLess    : Creates a window without any borders.
;   #PB_Window_ScreenCentered: Centers the window in the middle of the screen. x,y parameters are ignored.
;   #PB_Window_WindowCentered: Centers the window in the middle of the parent window ('ParentWindowID' must be specified). x,y parameters are ignored.
;   #PB_Window_Maximize      : Opens the window maximized. (Note: on Linux, Not all Windowmanagers support this)
;   #PB_Window_Minimize      : Opens the window minimized.
; 
; If the optional Flags parameter is Not specified, #PB_Window_SystemMenu will be used. 
; 
; All possible events in a window are handled With the WindowEvent() And WaitWindowEvent() functions. For special situations callbacks are used, see description at SetWindowCallback(). On Windows, the height And width of a window With a titlebar can't be less than around 100 pixels. To open smaller windows, use the "#PB_Window_BorderLess" flag. 
; 
; Note: When opening a Window from a thread, the thread must also call WindowEvent() Or WaitWindowEvent() in a loop To process events For this window, As window events are Not sent between different threads. 
; Supported OS 
; 
; All
; 


; IDE Options = PureBasic 4.20 Beta 3 (Windows - x86)
; CursorPosition = 94
; Folding = -
; UseIcon = cd.ico
; Executable = conDeb.exe
; HideErrorLog
; CompileSourceDirectory